using System;

class Node
{
	public Node(int value)
	{
		this.Value = value;
	}
	
	public int Value { get; set; }
	
	public Node Next { get; set; }
	public Node Previous { get; set; }
}

class LinkedList
{
	public LinkedList() { }
	
	public LinkedList(int[] values)
	{
		foreach(int value in values)
		{
			this.Add(value);
		}
	}
	
	public void Add(int value)
	{
		if(Root == null)
		{
			Root = new Node(value);
		}
		else
		{
			Node current = Root;
			while(current.Next != null)
			{
				current = current.Next;
			}
			
			current.Next = new Node(value);
			current.Next.Previous = current;
		}
	}
	
	public Node Root { get; private set; }
}

static class LinkedListHelper
{
	static public void Print(this LinkedList list)
	{
		Node current = list.Root;
		while(current != null)
		{
			Console.WriteLine(current.Value);
			current = current.Next;
		}
	}
}

class Program
{
	static public void Main()
	{
		int[] array = new int[]
		{
			10, 12, 44, 55, 34, 2, 5, 1, 100
		};
		
		LinkedList list = new LinkedList(array);
		
		list.Print();
	}
}