using System;

class Array
{
	private int[] array;
	
	public Array(int length)
	{
		array = new int[length];
	}
	
	public int this[int idx]
	{
		get { return array[idx]; }
		set { array[idx] = value; }
	}
	
	public int Length
	{
		get { return array.Length; }
	}
	
	public void Sort()
	{
		QuickSort(0, array.Length - 1);
	}
	
	private void QuickSort(int left, int right)
	{
		int pivot = array[left];
		int lhold = left;
		int rhold = right;
		
		while(left < right)
		{
			while(array[right] >= pivot && left < right)
			{
				--right;
			}
			
			if(left != right)
			{
				array[left] = array[right];
				++left;
			}
			
			while(array[left] <= pivot && left < right)
			{
				++left;
			}
			
			if(left != right)
			{
				array[right] = array[left];
				--right;
			}
		}
		
		array[left] = pivot;
		Console.WriteLine("array[left]: {0}", array[left]);
		
		pivot = left;
		Console.WriteLine("pivot: {0}", pivot);
		
		left = lhold;
		Console.WriteLine("left: {0}", left);
		
		right = rhold;
		Console.WriteLine("right: {0}", right);
		
		if(left < pivot)
		{
			QuickSort(left, pivot - 1);
		}
		
		if(right > pivot)
		{
			QuickSort(pivot + 1, right);
		}
	}
}

static class ArrayHelper
{
	static public void Print(this Array array)
	{
		for(int i = 0;i < array.Length;++i)
		{
			Console.Write("{0} ", array[i]);
		}
		Console.WriteLine();
	}
}

class Program
{
	static public void Main()
	{
		Array a = new Array(6);
		Random r = new Random();
		
		a[0] = 3;
		a[1] = 9;
		a[2] = 4;
		a[3] = 6;
		a[4] = 8;
		a[5] = 11;
		
		/*for(int i = 0;i < a.Length;++i)
		{
			a[i] = r.Next(100);
		}*/
		
		a.Print();
		a.Sort();
		a.Print();
	}
}